'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

var _mobxReact = require('mobx-react');

var _Parser = require('../Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _styles = require('./styles.pcss');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CheckboxField = (_dec = (0, _reactCssModules2.default)(_styles2.default, { allowMultiple: true }), (0, _mobxReact.observer)(_class = _dec(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(CheckboxField, _Component);

  function CheckboxField(props) {
    (0, _classCallCheck3.default)(this, CheckboxField);

    var _this = (0, _possibleConstructorReturn3.default)(this, (CheckboxField.__proto__ || (0, _getPrototypeOf2.default)(CheckboxField)).call(this, props));

    _this.onChange = _this.onChange.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(CheckboxField, [{
    key: 'onChange',
    value: function onChange(e) {
      this.props.onChange(e.target.checked);
      this.props.onBlur(e);
    }
  }, {
    key: 'getLabelPositionClass',
    value: function getLabelPositionClass() {
      var labelClass = 'display-' + this.props.field['#title_display'];
      if (_styles2.default[labelClass]) {
        return labelClass;
      }
      return '';
    }
  }, {
    key: 'getValue',
    value: function getValue() {
      return this.props.value === '1' || this.props.value === true ? 'checked' : false;
    }
  }, {
    key: 'render',
    value: function render() {
      var cssClasses = 'input-wrapper ' + this.getLabelPositionClass();
      var value = this.getValue();
      return _react2.default.createElement(
        'div',
        { styleName: cssClasses },
        _react2.default.createElement(
          'label',
          { htmlFor: this.key, styleName: 'checkbox-label' },
          _react2.default.createElement('input', {
            type: 'checkbox',
            styleName: 'checkbox',
            onChange: this.onChange,
            value: value,
            checked: value,
            name: this.props.field['#webform_key'],
            id: this.props.id || this.props.field['#webform_key'],
            disabled: !this.props.state.enabled,
            required: this.props.state.required
          }),
          _react2.default.createElement('span', { styleName: 'indicator' }),
          _react2.default.createElement(
            'span',
            { styleName: 'inner-label' },
            (0, _Parser2.default)(this.props.field['#description'])
          )
        )
      );
    }
  }]);
  return CheckboxField;
}(_react.Component), _class2.meta = {
  wrapper: _react2.default.createElement('fieldset', null),
  label: _react2.default.createElement('legend', null),
  field_display: {
    '#description': 'NO_DESCRIPTION'
  }
}, _class2.propTypes = {
  field: _propTypes2.default.shape({
    '#webform_key': _propTypes2.default.string.isRequired,
    '#title_display': _propTypes2.default.string,
    '#description': _propTypes2.default.string,
    '#required': _propTypes2.default.bool
  }).isRequired,
  value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number, _propTypes2.default.bool]).isRequired,
  id: _propTypes2.default.number,
  onChange: _propTypes2.default.func.isRequired,
  onBlur: _propTypes2.default.func.isRequired,
  state: _propTypes2.default.shape({
    required: _propTypes2.default.bool.isRequired,
    enabled: _propTypes2.default.bool.isRequired
  }).isRequired
}, _class2.defaultProps = {
  id: 0
}, _temp)) || _class) || _class);
exports.default = CheckboxField;