'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _dec, _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _getNested = require('get-nested');

var _getNested2 = _interopRequireDefault(_getNested);

var _fetchEverywhere = require('fetch-everywhere');

var _fetchEverywhere2 = _interopRequireDefault(_fetchEverywhere);

var _mobxReact = require('mobx-react');

var _reactCssModules = require('react-css-modules');

var _reactCssModules2 = _interopRequireDefault(_reactCssModules);

var _reactLoadScript = require('react-load-script');

var _reactLoadScript2 = _interopRequireDefault(_reactLoadScript);

var _google_tag = require('google_tag');

var _google_tag2 = _interopRequireDefault(_google_tag);

var _Forms = require('../Observables/Forms');

var _Forms2 = _interopRequireDefault(_Forms);

var _Parser = require('../Parser');

var _Parser2 = _interopRequireDefault(_Parser);

var _SubmitButton = require('../SubmitButton');

var _SubmitButton2 = _interopRequireDefault(_SubmitButton);

var _WebformElement = require('../WebformElement');

var _WebformElement2 = _interopRequireDefault(_WebformElement);

var _ThankYouMessage = require('../ThankYouMessage');

var _ThankYouMessage2 = _interopRequireDefault(_ThankYouMessage);

var _styles = require('./styles.pcss');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Webform = (_dec = (0, _reactCssModules2.default)(_styles2.default, { allowMultiple: true }), _dec(_class = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  (0, _inherits3.default)(Webform, _Component);

  function Webform(props) {
    (0, _classCallCheck3.default)(this, Webform);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Webform.__proto__ || (0, _getPrototypeOf2.default)(Webform)).call(this, props));

    _this.state = {
      status: Webform.formStates.DEFAULT,
      errors: {}
    };

    _this.key = props.form.form_id;

    /**
     * @var {Form}
     */
    _this.formStore = _this.getFormstore(props);

    _this.onSubmit = _this.onSubmit.bind(_this);
    _this.converted = _this.converted.bind(_this);
    _this.submit = _this.submit.bind(_this);
    return _this;
  }

  (0, _createClass3.default)(Webform, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this2 = this;

      var GTM = (0, _getNested2.default)(function () {
        return _this2.props.settings.tracking.gtm_id;
      }) || this.props.form.settings.nm_gtm_id;

      if (GTM) {
        _google_tag2.default.addTag(GTM);
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.formStore = this.getFormstore(nextProps);
    }
  }, {
    key: 'onSubmit',
    value: function onSubmit(e) {
      e.preventDefault();

      // If the 'onSubmit' is being overwritten, use that function.
      // If it returns false, don't submit, otherwise continue.
      if (typeof this.onSubmitOverwrite === 'function') {
        var result = this.onSubmitOverwrite(e);
        if (!result) return result;
      }

      // Make sure that all errors are visible by marking all visible fields as blurred.
      this.formStore.visibleFields.forEach(function (field) {
        field.isBlurred = true;
      });

      var isValid = this.isValid();
      if (isValid) {
        return this.updateSubmission();
      }
      console.warn('The user tried to submit a form, but not all fields are valid.');

      return true;
    }
  }, {
    key: 'getFormstore',
    value: function getFormstore(props) {
      return _Forms2.default.getForm(props.form.form_id, {
        form: props.form,
        settings: props.settings,
        defaultValues: this.props.defaultValues
      });
    }
  }, {
    key: 'getFormElements',
    value: function getFormElements() {
      var _this3 = this;

      var formElements = (0, _getNested2.default)(function () {
        return _this3.props.form.elements;
      }, []);
      return formElements.map(function (field) {
        return _react2.default.createElement(_WebformElement2.default, {
          key: field['#webform_key'],
          field: field,
          formStore: _this3.formStore,
          settings: _this3.props.form.settings,
          webformSettings: _this3.props.settings,
          status: _this3.state.status,
          form: _this3.props.form
        });
      });
    }
  }, {
    key: 'converted',
    value: function converted() {
      this.props.onSubmitSuccess({
        webform: this,
        response: this.response
      }); // Trigger onSubmitSuccess hook.
    }
  }, {
    key: 'isValid',
    value: function isValid() {
      return this.formStore.valid;
    }
  }, {
    key: 'isMultipage',
    value: function isMultipage() {
      var _this4 = this;

      return (0, _getNested2.default)(function () {
        return _this4.props.form.elements;
      }, []).find(function (element) {
        return element['#webform_key'] === 'wizard_pages';
      }) !== undefined;
    }
  }, {
    key: 'updateSubmission',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee() {
        var response;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.next = 2;
                return this.props.onSubmit(this);

              case 2:
                response = _context.sent;

                if (!(!response || response.submit !== false)) {
                  _context.next = 7;
                  break;
                }

                _context.next = 6;
                return this.submit();

              case 6:
                response = _context.sent;

              case 7:

                if (response.status === 200 || response.status === 201) {
                  this.response = response;
                  this.setState({ status: Webform.formStates.SENT });
                } else {
                  this.setState({ status: Webform.formStates.ERROR, errors: response.errors || [] });
                  this.props.onSubmitFail(this); // Trigger onSubmitFail hook.
                }

              case 8:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function updateSubmission() {
        return _ref.apply(this, arguments);
      }

      return updateSubmission;
    }()
  }, {
    key: 'submit',
    value: function () {
      var _ref2 = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee2() {
        var extraFields = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
        var headers, values;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                // eslint-disable-next-line no-undef
                headers = new Headers({
                  'Content-Type': 'application/json',
                  'X-CSRF-Token': this.props.form.token
                });
                values = (0, _assign2.default)({}, this.props.hiddenData);

                this.formStore.visibleFields.filter(function (field) {
                  return !field.isEmpty;
                }).forEach(function (field) {
                  values[field.key] = field.value;
                });
                if (!extraFields.in_draft) this.setState({ status: Webform.formStates.PENDING });
                return _context2.abrupt('return', (0, _fetchEverywhere2.default)(this.props.settings.cmsBaseUrl + '/api/v1/form?_format=json', {
                  headers: headers,
                  method: 'POST',
                  body: (0, _stringify2.default)((0, _assign2.default)({
                    form_id: this.props.form.form_id
                  }, extraFields, values))
                }).then(function (response) {
                  return response.json();
                }).then(function (_ref3) {
                  var _ref3$status = _ref3.status,
                      status = _ref3$status === undefined ? 400 : _ref3$status,
                      _ref3$errors = _ref3.errors,
                      errors = _ref3$errors === undefined ? false : _ref3$errors,
                      response = (0, _objectWithoutProperties3.default)(_ref3, ['status', 'errors']);
                  return (0, _extends3.default)({ status: status, errors: errors }, response);
                }).catch(console.error));

              case 5:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function submit() {
        return _ref2.apply(this, arguments);
      }

      return submit;
    }()
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var formElements = this.getFormElements();
      var multipage = this.isMultipage();

      var requiredHint = null;
      if (this.formStore.visibleFields.find(function (field) {
        return field.required;
      }) && this.props.form.settings.nm_required_hint) {
        requiredHint = _react2.default.createElement(
          'span',
          null,
          (0, _Parser2.default)(this.props.form.settings.nm_required_hint)
        );
      }

      var errors = (0, _keys2.default)(this.state.errors).map(function (error) {
        return _react2.default.createElement(
          'li',
          { key: error },
          _react2.default.createElement(
            'span',
            { styleName: 'element error' },
            (0, _Parser2.default)(_this5.state.errors[error])
          )
        );
      });

      return _react2.default.createElement(
        _mobxReact.Provider,
        { formStore: this.formStore, submit: this.submit, webform: this },
        _react2.default.createElement(
          'div',
          { styleName: 'webform' },
          _react2.default.createElement(
            'h1',
            { styleName: 'formtitle' },
            this.props.settings.title
          ),
          this.state.status === Webform.formStates.ERROR && errors,
          this.state.status !== Webform.formStates.SENT && _react2.default.createElement(
            'form',
            {
              method: 'POST',
              onSubmit: this.onSubmit,
              name: this.props.form.form_id,
              id: this.props.form.form_id,
              noValidate: this.props.noValidation
            },
            requiredHint,
            formElements,
            !multipage && _react2.default.createElement(_SubmitButton2.default, {
              form: this.props.form,
              status: this.state.status
            })
          ),
          this.props.showThankYouMessage && this.state.status === Webform.formStates.SENT && _react2.default.createElement(_ThankYouMessage2.default, { message: this.props.form.settings.confirmation_message }),
          this.props.settings.tracking !== false && _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_reactLoadScript2.default, {
              url: '//cdn-static.formisimo.com/tracking/js/tracking.js',
              onLoad: function onLoad() {},
              onError: function onError() {}
            }),
            this.state.status === Webform.formStates.SENT && _react2.default.createElement(_reactLoadScript2.default, {
              url: '//cdn-static.formisimo.com/tracking/js/conversion.js',
              onLoad: this.converted,
              onError: function onError() {}
            })
          )
        )
      );
    }
  }]);
  return Webform;
}(_react.Component), _class2.formStates = {
  DEFAULT: 'DEFAULT',
  SENT: 'SENT',
  ERROR: 'ERROR',
  PENDING: 'PENDING',
  CONVERTED: 'CONVERTED'
}, _class2.analyticsEventsCategories = {
  SUCCESSFUL: 'Successful submission',
  ERROR: 'Error during submission'
}, _class2.analyticsEventsActions = {
  FORM_SUBMISSION: 'Form Submission'
}, _class2.propTypes = {
  settings: _propTypes2.default.shape({
    title: _propTypes2.default.string,
    cmsBaseUrl: _propTypes2.default.string.isRequired,
    tracking: _propTypes2.default.oneOfType([_propTypes2.default.shape({
      gtm_id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool])
    }), _propTypes2.default.bool])
  }).isRequired,
  form: _propTypes2.default.shape({
    form_id: _propTypes2.default.string.isRequired,
    settings: _propTypes2.default.shape({
      nm_gtm_id: _propTypes2.default.string,
      nm_required_hint: _propTypes2.default.string,
      confirmation_message: _propTypes2.default.string
    }),
    elements: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      '#type': _propTypes2.default.string.isRequired
    })).isRequired,
    token: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool])
  }).isRequired,
  onSubmit: _propTypes2.default.func,
  onSubmitSuccess: _propTypes2.default.func,
  onSubmitFail: _propTypes2.default.func,
  defaultValues: _propTypes2.default.objectOf(_propTypes2.default.string),
  hiddenData: _propTypes2.default.objectOf(_propTypes2.default.string),
  noValidation: _propTypes2.default.bool,
  showThankYouMessage: _propTypes2.default.bool
}, _class2.defaultProps = {
  onSubmit: function onSubmit() {},
  onSubmitSuccess: function onSubmitSuccess() {},
  onSubmitFail: function onSubmitFail() {},
  nm_gtm_id: false,
  settings: {
    tracking: false
  },
  defaultValues: {},
  hiddenData: {},
  noValidation: true,
  showThankYouMessage: true
}, _temp)) || _class) || _class);
exports.default = Webform;